---
- name: "Install Docker, deploy some certificates and enable SWARM mode"
  hosts: "{{ tower_hosts | default([]) }}:&role-install-docker:&role-install-docker-swarm:&role-prepare-host"
  gather_facts: true
  become: true
  become_method: "sudo"
  become_user: "root"

  tasks:

    - name: "Include labocbz.install_docker"
      tags:
        - "labocbz.install_docker"
      vars:
        install_docker__compose_version: "{{ inv__install_docker__compose_version  }}"
        install_docker__enable_swap: "{{ inv__install_docker__enable_swap  }}"
        install_docker__system_clean: "{{ inv__install_docker__system_clean  }}"
        install_docker__insecure_registries: "{{ inv__install_docker__insecure_registries | default([]) }}"
      ansible.builtin.include_role:
        name: "labocbz.install_docker"

    - name: "Flush loaded handler for Docker"
      ansible.builtin.meta: "flush_handlers"

    - name: "Include labocbz.import_certificate"
      tags:
        - "labocbz.import_certificate"
      loop: "{{ inv__import_certificate__bundles__install_docker_swarm }}"
      loop_control:
        loop_var: "certificate_bundle"
      vars:
        import_certificate__bundle_name: "{{ certificate_bundle.name }}"
        import_certificate__bundle_type: "{{ certificate_bundle.type }}"
        import_certificate__bundle_src: "{{ certificate_bundle.src }}"
        import_certificate__bundle_dest: "{{ certificate_bundle.dest }}"
        import_certificate__bundle_src_user: "{{ certificate_bundle.src_user }}"
        import_certificate__bundle_src_password: "{{ certificate_bundle.src_password }}"
        import_certificate__bundle_dest_user: "{{ certificate_bundle.dest_user }}"
        import_certificate__bundle_dest_group: "{{ certificate_bundle.dest_group }}"
        import_certificate__bundle_dest_mode: "{{ certificate_bundle.dest_mode }}"
      ansible.builtin.include_role:
        name: "labocbz.import_certificate"

    - name: "Include labocbz.prepare_host"
      tags:
        - "labocbz.prepare_host"
      vars:
        prepare_host__packages_to_install: "{{ inv__prepare_host__packages_to_install }}"
      ansible.builtin.include_role:
        name: "labocbz.prepare_host"

    - name: "Include labocbz.install_docker_swarm"
      tags:
        - "labocbz.install_docker_swarm"
      vars:
        install_docker_swarm: "{{ inv__install_docker_swarm  }}"
        install_docker_swarm__is_manager: "{{ inv__install_docker_swarm_is_manager  }}"
        install_docker_swarm__portainer: "{{ inv__install_docker_swarm_portainer  }}"
      ansible.builtin.include_role:
        name: "labocbz.install_docker_swarm"
